"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useWave;
var React = _interopRequireWildcard(require("react"));
var _useEvent = _interopRequireDefault(require("rc-util/lib/hooks/useEvent"));
var _WaveEffect = _interopRequireDefault(require("./WaveEffect"));
var _configProvider = require("../../config-provider");
var _useToken = _interopRequireDefault(require("../../theme/useToken"));
function useWave(nodeRef, className, component) {
  const {
    wave
  } = React.useContext(_configProvider.ConfigContext);
  const [, token] = (0, _useToken.default)();
  const showWave = (0, _useEvent.default)(event => {
    const node = nodeRef.current;
    if ((wave === null || wave === void 0 ? void 0 : wave.disabled) || !node) {
      return;
    }
    const {
      showEffect
    } = wave || {};
    // Customize wave effect
    (showEffect || _WaveEffect.default)(node, {
      className,
      token,
      component,
      event
    });
  });
  return showWave;
}